CapstoneProject/Controllers/ToDoEntryController.cs
using CapstoneProject.DBContext;
using CapstoneProject.DomainModels;
using CapstoneProject.Enum;
using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;

namespace CapstoneProject.Controllers
{
    /// <summary>
    /// Base class(controller) for working with ToDoEntries of a ToDoList.
    /// </summary>
    public class ToDoEntryController : Controller
    {
        private readonly CapStoneDbContext _context;

        /// <summary>
        /// Gets a reference to existing DataBase in a controller.
        /// </summary>
        public ToDoEntryController(CapStoneDbContext context)
        {
            _context = context;
        }

        /// <summary>
        /// Gets Data from DbContext and Displays all ToDoEntries of
        /// a given ToDoList <paramref name="toDoListId"/> in a DataBase.
        /// </summary>
        /// <param name="toDoListId">Id of a ToDoList, entries of which to display.</param>
        /// <param name="status">Status of ToDoEntries. By default, only not completed Nodes will be displayed.</param>
        /// <returns>If status is null     -----> The created <see cref="ViewResult"/> with only not completed ToDoEnrties of given ToDoList.</returns>
        /// <returns>If status is not null -----> The created <see cref="ViewResult"/> with all ToDoEnrties of given ToDoList.</returns>
        public IActionResult Index(int toDoListId, ToDoEntryStatus? status = null)
        {
            ViewBag.ToDoListId = toDoListId;
            ViewBag.ToDoListName = _context.ToDoLists.Find(toDoListId)?.Name;

            var temp = _context.ToDoEntries.Where(s => s.ToDoListId == toDoListId).ToList();

            if (status is null)
            {
                return View(temp.Where(s => s.Status != ToDoEntryStatus.Completed).ToList());
            }
            else
            {
                return View(temp);
            }
        }

        /// <summary>
        /// Get type of Create method.
        /// Displays view with form to create a ToDoEntry.
        /// </summary>
        /// <param name="id">Id of a ToDoList, where to create a ToDoEntry.</param>
        /// <returns>The created <see cref="ViewResult"/> with forms to fill in.</returns>
        [HttpGet]
        public IActionResult Create(int id)
        {
            ViewBag.Id = id;
            ToDoEntry toDoEntry = new ToDoEntry();
            return View(toDoEntry);
        }

        /// <summary>
        /// Post type of Create method.
        /// Gets a filled form of a ToDoEntry and add it to a DataBase.
        /// </summary>
        /// <param name="tdeObj">ToDoEntry to add to a DataBase.</param>
        /// <returns>If <paramref name="tdeObj"> is valid   ---> The created <see cref="RedirectToActionResult"/> to Index action of the same controller.</returns>
        /// <returns>If <paramref name="tdeObj"> is invalid ---> The created <see cref="ViewResult"/> of the same page.</returns>
        [HttpPost]
        public async Task<IActionResult> Create([Bind("Name, Description, DueDate, CreatedDate, Status, ToDoListId")] ToDoEntry tdeObj)
        {
            if (tdeObj.DueDate < DateTime.Now)
            {
                if (TempData != null)
                    TempData["DueDate"] = "DueDate is Wrong !";

                return View(tdeObj);
            }

            if (ModelState.IsValid)
            {
                tdeObj.CreatedDate = DateTime.Now;
                tdeObj.ToDoList = _context.ToDoLists.Find(tdeObj.ToDoListId);

                _context.ToDoEntries.Add(tdeObj);
                await _context.SaveChangesAsync();
                TempData["ResultOk"] = "Node Added Successfully !";

                return RedirectToAction("Index", new {toDoListId = tdeObj.ToDoListId});
            }

            return View(tdeObj);
        }

        /// <summary>
        /// Get type of Edit method.
        /// Displays view with form to edit a ToDoEntry.
        /// </summary>
        /// <param name="id">Id of a ToDoEntry to edit in DataBase.</param>
        /// <returns>If <paramref name="id"> is valid   ---> The created <see cref="ViewResult"/> with form to fill in.</returns>
        /// <returns>If <paramref name="id"> is invalid ---> The created <see cref="NotFoundResult"/> page.</returns>
        [HttpGet]
        public IActionResult Edit(int? id)
        {
            if (id == null)
            {
                return NotFound();
            }
            var tdeFromDb = _context.ToDoEntries.Find(id);

            if (tdeFromDb == null)
            {
                return NotFound();
            }

            return View(tdeFromDb);
        }

        /// <summary>
        /// Post type of Edit method.
        /// Gets a edited form of a ToDoEntry and update it in a DataBase.
        /// </summary>
        /// <param name="id">Id of a ToDoEntry to edit in DataBase.</param>
        /// <returns>If <paramref name="id"> is valid   ---> The created <see cref="RedirectToActionResult"/> to Index action of the same controller.</returns>
        /// <returns>If <paramref name="id"> is invalid ---> The created <see cref="ViewResult"/> of the same page.</returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(ToDoEntry tdeObj)
        {
            if (tdeObj.DueDate < DateTime.Now)
            {
                TempData["DueDate"] = "DueDate is Wrong";
                return View(tdeObj);
            }

            if (ModelState.IsValid)
            {
                _context.ToDoEntries.Find(tdeObj.Id).Name = tdeObj.Name;
                _context.ToDoEntries.Find(tdeObj.Id).Description = tdeObj.Description;
                _context.ToDoEntries.Find(tdeObj.Id).DueDate = tdeObj.DueDate;
                _context.ToDoEntries.Find(tdeObj.Id).Status = tdeObj.Status;
                await _context.SaveChangesAsync();
                TempData["ResultOk"] = "Node Updated Successfully !";
                return RedirectToAction("Index", new {toDoListId = tdeObj.ToDoListId});
            }

            return View(tdeObj);
        }

        /// <summary>
        /// Delete an existing ToDoEntry.
        /// </summary>
        /// <param name="id">Id of a ToDoEntry to delete from DatatBase.</param>
        /// <returns>If <paramref name="id"> is valid   ---> The created <see cref="RedirectToActionResult"/> to Index action of the same controller.</returns>
        /// <returns>If <paramref name="id"> is invalid ---> The created <see cref="NotFoundResult"/> page.</returns>
        public async Task<IActionResult> Delete(int id)
        {
            var deleteRecord = _context.ToDoEntries.Find(id);
            if (deleteRecord == null)
            {
                return NotFound();
            }

            _context.ToDoEntries.Remove(deleteRecord);
            await _context.SaveChangesAsync();
            TempData["ResultOk"] = "Node Deleted Successfully !";
            return RedirectToAction("Index", new {toDoListId = deleteRecord.ToDoListId});
        }
    }
}

CapstoneProject/Controllers/ToDoListController.cs
using CapstoneProject.DomainModels;
using CapstoneProject.DBContext;
using Microsoft.AspNetCore.Mvc;
using CapstoneProject.Enum;

namespace CapstoneProject.Controllers
{
    /// <summary>
    /// A base class(controller) for Capstone project that works with ToDoLists.
    /// </summary>
    public class ToDoListController : Controller
    {
        private readonly CapStoneDbContext _context;

        /// <summary>
        /// Gets a reference to existing DataBase in a controller.
        /// </summary>
        public ToDoListController(CapStoneDbContext context)
        {
            _context = context;
        }

        /// <summary>
        /// Gets Data from DbContext and Displays all ToDoLists in a DataBase.
        /// </summary>
        /// <returns>The created <see cref="ViewResult"/> with all ToDoLists.</returns>
        public IActionResult Index()
        {
            IEnumerable<ToDoList> objCatlist = _context.ToDoLists;
            return View(objCatlist);
        }

        /// <summary>
        /// Get type of Create method.
        /// Displays view with form to create a ToDoList.
        /// </summary>
        /// <returns>The created <see cref="ViewResult"/> with forms to fill in.</returns>
        [HttpGet]
        public IActionResult Create()
        {
            ToDoList toDoList = new ToDoList();
            return View(toDoList);
        }

        /// <summary>
        /// Post type of Create method.
        /// Gets a filled form of a ToDoList and add it to DataBase.
        /// </summary>
        /// <param name="tdlObj">ToDoList to add to DataBase.</param>
        /// <returns>If <paramref name="tdlObj"> is valid   ---> The created <see cref="RedirectToActionResult"/> to Index action of the same controller.</returns>
        /// <returns>If <paramref name="tdlObj"> is invalid ---> The created <see cref="ViewResult"/> of the same page.</returns>
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create(ToDoList tdlObj)
        {
            if (ModelState.IsValid)
            {
                tdlObj.CreatedDate = DateTime.Now;
                _context.ToDoLists.Add(tdlObj);
                await _context.SaveChangesAsync();
                TempData["ResultOk"] = "List Added Successfully !";
                return RedirectToAction("Index");
            }

            return View(tdlObj);
        }

        /// <summary>
        /// Edit an existing ToDoList in DataBase.
        /// </summary>
        /// <param name="id">Id of a ToDoList to edit in DataBase.</param>
        /// <returns>If <paramref name="id"> is valid   ---> The created <see cref="RedirectToActionResult"/> to Index action of the same controller.</returns>
        /// <returns>If <paramref name="id"> is invalid ---> The created <see cref="NotFoundResult"/> page.</returns>
        public IActionResult Edit(int? id)
        {
            if (id == null || id == 0)
            {
                return NotFound();
            }
            var tdlFromDb = _context.ToDoLists.Find(id);

            if (tdlFromDb == null)
            {
                return NotFound();
            }

            return RedirectToAction("Index", "ToDoEntry", new {toDoListId = tdlFromDb.Id, status = ToDoEntryStatus.Completed});
        }

        /// <summary>
        /// Delete an existing ToDoList.
        /// </summary>
        /// <param name="id">Id of a ToDoList to delete from DatatBase.</param>
        /// <returns>If <paramref name="id"> is valid   ---> The created <see cref="RedirectToActionResult"/> to Index action of the same controller.</returns>
        /// <returns>If <paramref name="id"> is invalid ---> The created <see cref="NotFoundResult"/> page.</returns>
        public async Task<IActionResult> Delete(int id)
        {
            var deleteRecord = await _context.ToDoLists.FindAsync(id);
            if (deleteRecord == null)
            {
                return NotFound();
            }
            _context.ToDoLists.Remove(deleteRecord);
            await _context.SaveChangesAsync();
            TempData["ResultOk"] = "List Deleted Successfully !";
            return RedirectToAction("Index");
        }
    }
}

CapstoneProject/Views/ToDoEntry/Create.cshtml
@model CapstoneProject.DomainModels.ToDoEntry
@if (TempData["DueDate"] != null) {
     <h5>@TempData["DueDate"]</h5>
}
<div class="container shadow p-5">
    <div class="row pb-2">
        <h2>Add New Node</h2>
    </div>

    <form method="post">
        <div asp-validation-summary="All"></div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label asp-for="Name">Node Name</label>
                <input type="text" class="form-control mb-3" asp-for="Name" placeholder="Enter Name">
                <span asp-validation-for="Name" class=" alert-danger"></span>
            </div>
            <div class="form-group col-md-6">
                <label asp-for="Description">Description</label>
                <textarea asp-for="Description" class="form-control"></textarea>
                <span asp-validation-for="Description" class=" alert-danger"></span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6 mb-3">
                <label asp-for="DueDate">DueDate</label>
                <input type="datetime-local" class="form-control" asp-for="DueDate">
                <span asp-validation-for="DueDate" class=" alert-danger"></span>            
            </div>
            <div class="form-group col-md-6 mb-3">
                <label asp-for="Status">Status</label>
                <select asp-for="Status" class="form-select" title="Default select example">
                    <option value="@((int)CapstoneProject.Enum.ToDoEntryStatus.Completed)">Completed</option>
                    <option value="@((int)CapstoneProject.Enum.ToDoEntryStatus.InProgress)">In Progress</option>
                    <option value="@((int)CapstoneProject.Enum.ToDoEntryStatus.NotStarted)">Not Started</option>
                </select>          
            </div>
        </div>
        <input type="hidden" name="ToDoListId" value="@ViewBag.Id" />

        <button type="submit" class="btn btn-lg btn-primary p-2"><i class="bi bi-file-plus-fill"></i>Save</button>
        <a asp-controller="ToDoEntry" asp-action="Index" asp-route-toDoListId="@ViewBag.Id" class="btn btn-lg btn-warning p-2">Back To List</a>
    </form>

</div>


@*//for front end validations*@

@section Scripts{
    @{
        <partial name="_ValidationScriptsPartial" />
    }
    }

CapstoneProject/Views/ToDoEntry/Edit.cshtml
@model CapstoneProject.DomainModels.ToDoEntry
@if (TempData["DueDate"] != null){
        <h5>@TempData["DueDate"]</h5>
}
<div class="container shadow p-5">
    <div class="row pb-2">
        <h2>Edit Node: @Model.Name</h2>
    </div>

    <form method="post">
        <div asp-validation-summary="All"></div>

        <div class="form-row">
            <div class="form-group col-md-6">
                <label asp-for="Name">Node Name</label>
                <input type="text" class="form-control mb-3" asp-for="Name" placeholder="Enter Name">
                <span asp-validation-for="Name" class=" alert-danger"></span>
            </div>
            <div class="form-group col-md-6">
                <label asp-for="Description">Description</label>
                <textarea asp-for="Description" class="form-control"></textarea>
                <span asp-validation-for="Description" class=" alert-danger"></span>
            </div>
        </div>

        <div class="form-row">
            <div class="form-group col-md-6 mb-3">
                <label asp-for="DueDate">DueDate</label>
                <input type="datetime-local" class="form-control" asp-for="DueDate">
                <span asp-validation-for="DueDate" class=" alert-danger"></span>            
            </div>
            <div class="form-group col-md-6 mb-3">
                <label asp-for="Status">Status</label>
                <select asp-for="Status" class="form-select" title="Default select example">
                    <option value="@((int)CapstoneProject.Enum.ToDoEntryStatus.Completed)">Completed</option>
                    <option value="@((int)CapstoneProject.Enum.ToDoEntryStatus.InProgress)">In Progress</option>
                    <option value="@((int)CapstoneProject.Enum.ToDoEntryStatus.NotStarted)">Not Started</option>
                </select>          
            </div>
        </div>
        <input type="hidden" name="ToDoListId" value="@Model.ToDoListId" />

        <button type="submit" class="btn btn-lg btn-primary p-2"><i class="bi bi-file-plus-fill"></i>Save</button>
        <a asp-controller="ToDoEntry" asp-action="Index" asp-route-toDoListId="@Model.ToDoListId" class="btn btn-lg btn-warning p-2">Back To List</a>
    </form>

</div>

@*//for front end validations*@

@section Scripts{
    @{
        <partial name="_ValidationScriptsPartial" />
    }
    }

CapstoneProject/Views/ToDoEntry/Index.cshtml
@model ICollection<CapstoneProject.DomainModels.ToDoEntry>

@{
    ViewData["Title"] = "Index";
}

@if (TempData["ResultOk"] != null)
{
        <h1 class="alert-success">@TempData["ResultOk"]</h1>
}

<div class="container shadow p-5">

    <h2 class="text-center mb-3">@ViewBag.ToDoListName</h2>

    <div class="col mb-3">
        <a asp-controller="ToDoEntry" asp-action="Create" asp-route-id="@ViewBag.ToDoListId" class="btn btn-lg btn-primary"><i class="bi bi-file-plus-fill"></i>Add Node</a>
    </div>
    <table class="table table-bordered table-hover">
        <thead>
            <tr>
                <th scope="col">Node Name</th>
                <th scope="col">Deadline</th>
                <th scope="col">CreatedOn</th>
                <th scope="col">Status</th>
                <th></th>
            </tr>
        </thead>
        <tbody>
            @if (Model.Count == 0)
            {
                <tr>
                    <td width="100%">
                        List is Empty yet ...
                    </td>
                </tr>
            }
            else
            {
            @foreach (var item in Model)
            {
                    <tr>
                        <td width="20%">
                        @item.Name
                        </td>
                        <td width="20%">
                        @item.DueDate
                        </td>
                        <td width="20%">
                        @item.CreatedDate
                        </td>
                        <td width="20%">
                        @item.Status
                        </td>
                        <td>
                            <div role="group" class="w-60 btn-group">
                                <a asp-controller="ToDoEntry" asp-action="Edit" asp-route-id="@item.Id" class=" btn btn-sm btn-primary"><i class="bi bi-pencil-square"></i>Edit</a>&nbsp;
                                <a asp-controller="ToDoEntry" asp-action="Delete" asp-route-id="@item.Id" class="btn btn-sm btn-danger"><i class="bi bi-trash-fill"></i>Delete</a>
                            </div>
                        </td>
                    </tr>
            }
            }
        </tbody>
    </table>

    <a asp-controller="ToDoList" asp-action="Index" class="btn btn-lg btn-warning p-2">Back To List</a>
    <a asp-controller="ToDoEntry" asp-action="Index" asp-route-toDoListId="@ViewBag.ToDoListId" asp-route-status="@CapstoneProject.Enum.ToDoEntryStatus.Completed" class=" btn btn-sm btn-primary"><i class="bi bi-pencil-square"></i>Show Completed</a>
    <a asp-controller="ToDoEntry" asp-action="Index" asp-route-toDoListId="@ViewBag.ToDoListId" class=" btn btn-sm btn-primary"><i class="bi bi-pencil-square"></i>Hide Completed</a>
</div>